diff --git a/web/pgadmin/tools/debugger/__init__.py b/web/pgadmin/tools/debugger/__init__.py
index 35a0378c..46c6fd81 100644
--- a/web/pgadmin/tools/debugger/__init__.py
+++ b/web/pgadmin/tools/debugger/__init__.py
@@ -69,10 +69,29 @@ class DebuggerModule(PgAdminModule):
                              'will be opened in a new browser tab.')
         )
 
+
+    def get_exposed_url_endpoints(self):
+        """
+        Returns the list of URLs exposed to the client.
+        """
+        return ['debugger.index','debugger.init_for_function',
+                'debugger.init_for_trigger',
+                'debugger.direct', 'debugger.initialize_target_for_function',
+                'debugger.initialize_target_for_trigger', 'debugger.close',
+                'debugger.restart',
+                'debugger.start_listener', 'debugger.execute_query',
+                'debugger.messages',
+                'debugger.start_execution', 'debugger.set_breakpoint',
+                'debugger.clear_all_breakpoint', 'debugger.deposit_value',
+                'debugger.select_frame', 'debugger.get_arguments',
+                'debugger.set_arguments',
+                'debugger.poll_end_execution_result', 'debugger.poll_result'
+            ]
+
 blueprint = DebuggerModule(MODULE_NAME, __name__)
 
 
-@blueprint.route("/")
+@blueprint.route("/", endpoint='index')
 @login_required
 def index():
     return bad_request(errormsg=gettext("This URL cannot be called directly!"))
@@ -120,8 +139,14 @@ def update_session_function_transaction(trans_id, data):
     session['functionData'] = function_data
 
 
-@blueprint.route('/init/<node_type>/<int:sid>/<int:did>/<int:scid>/<int:fid>', methods=['GET'])
-@blueprint.route('/init/<node_type>/<int:sid>/<int:did>/<int:scid>/<int:fid>/<int:trid>', methods=['GET'])
+@blueprint.route(
+    '/init/<node_type>/<int:sid>/<int:did>/<int:scid>/<int:fid>',
+    methods=['GET'], endpoint='init_for_function'
+)
+@blueprint.route(
+    '/init/<node_type>/<int:sid>/<int:did>/<int:scid>/<int:fid>/<int:trid>',
+    methods=['GET'], endpoint='init_for_trigger'
+)
 @login_required
 def init_function(node_type, sid, did, scid, fid, trid=None):
     """
@@ -291,7 +316,7 @@ def init_function(node_type, sid, did, scid, fid, trid=None):
     )
 
 
-@blueprint.route('/direct/<int:trans_id>', methods=['GET'])
+@blueprint.route('/direct/<int:trans_id>', methods=['GET'], endpoint='direct')
 @login_required
 def direct_new(trans_id):
     debugger_data = session['debuggerData']
@@ -333,10 +358,16 @@ def direct_new(trans_id):
     )
 
 
-@blueprint.route('/initialize_target/<debug_type>/<int:sid>/<int:did>/<int:scid>/<int:func_id>',
-                 methods=['GET', 'POST'])
-@blueprint.route('/initialize_target/<debug_type>/<int:sid>/<int:did>/<int:scid>/<int:func_id>/<int:tri_id>',
-                 methods=['GET', 'POST'])
+@blueprint.route(
+    '/initialize_target/<debug_type>/<int:sid>/<int:did>/<int:scid>/<int:func_id>',
+    methods=['GET', 'POST'],
+    endpoint='initialize_target_for_function'
+)
+@blueprint.route(
+    '/initialize_target/<debug_type>/<int:sid>/<int:did>/<int:scid>/<int:func_id>/<int:tri_id>',
+    methods=['GET', 'POST'],
+    endpoint='initialize_target_for_trigger'
+)
 @login_required
 def initialize_target(debug_type, sid, did, scid, func_id, tri_id=None):
     """
@@ -524,7 +555,7 @@ def initialize_target(debug_type, sid, did, scid, func_id, tri_id=None):
                                     'newBrowserTab': new_browser_tab})
 
 
-@blueprint.route('/close/<int:trans_id>', methods=["DELETE"])
+@blueprint.route('/close/<int:trans_id>', methods=["DELETE"], endpoint='close')
 def close(trans_id):
     """
     close(trans_id)
@@ -564,7 +595,7 @@ def close(trans_id):
         return internal_server_error(errormsg=str(e))
 
 
-@blueprint.route('/restart/<int:trans_id>', methods=['GET'])
+@blueprint.route('/restart/<int:trans_id>', methods=['GET'], endpoint='restart')
 @login_required
 def restart_debugging(trans_id):
     """
@@ -623,7 +654,10 @@ def restart_debugging(trans_id):
     return make_json_response(data={'status': status})
 
 
-@blueprint.route('/start_listener/<int:trans_id>', methods=['GET', 'POST'])
+@blueprint.route(
+    '/start_listener/<int:trans_id>', methods=['GET', 'POST'],
+    endpoint='start_listener'
+)
 @login_required
 def start_debugger_listener(trans_id):
     """
@@ -810,8 +844,10 @@ def start_debugger_listener(trans_id):
 
     return make_json_response(data={'status': status, 'result': result})
 
-
-@blueprint.route('/execute_query/<int:trans_id>/<query_type>', methods=['GET'])
+@blueprint.route(
+    '/execute_query/<int:trans_id>/<query_type>', methods=['GET'],
+    endpoint='execute_query'
+)
 @login_required
 def execute_debugger_query(trans_id, query_type):
     """
@@ -892,7 +928,7 @@ def execute_debugger_query(trans_id, query_type):
     )
 
 
-@blueprint.route('/messages/<int:trans_id>/', methods=["GET"])
+@blueprint.route('/messages/<int:trans_id>/', methods=["GET"],endpoint='messages')
 @login_required
 def messages(trans_id):
     """
@@ -957,9 +993,10 @@ def messages(trans_id):
         return internal_server_error(errormsg=str(result))
 
 
-
-
-@blueprint.route('/start_execution/<int:trans_id>/<int:port_num>', methods=['GET'])
+@blueprint.route(
+    '/start_execution/<int:trans_id>/<int:port_num>', methods=['GET'],
+    endpoint='start_execution'
+)
 @login_required
 def start_execution(trans_id, port_num):
     """
@@ -1027,7 +1064,10 @@ def start_execution(trans_id, port_num):
     return make_json_response(data={'status': 'Success', 'result': res_port['rows'][0]['pldbg_attach_to_port']})
 
 
-@blueprint.route('/set_breakpoint/<int:trans_id>/<int:line_no>/<int:set_type>', methods=['GET'])
+@blueprint.route(
+    '/set_breakpoint/<int:trans_id>/<int:line_no>/<int:set_type>',
+    methods=['GET'], endpoint='set_breakpoint'
+)
 @login_required
 def set_clear_breakpoint(trans_id, line_no, set_type):
     """
@@ -1096,7 +1136,10 @@ def set_clear_breakpoint(trans_id, line_no, set_type):
     return make_json_response(data={'status': status, 'result': result['rows']})
 
 
-@blueprint.route('/clear_all_breakpoint/<int:trans_id>', methods=['POST'])
+@blueprint.route(
+    '/clear_all_breakpoint/<int:trans_id>', methods=['POST'],
+    endpoint='clear_all_breakpoint'
+)
 @login_required
 def clear_all_breakpoint(trans_id):
     """
@@ -1148,7 +1191,9 @@ def clear_all_breakpoint(trans_id):
     return make_json_response(data={'status': status, 'result': result['rows']})
 
 
-@blueprint.route('/deposit_value/<int:trans_id>', methods=['POST'])
+@blueprint.route(
+    '/deposit_value/<int:trans_id>', methods=['POST'], endpoint='deposit_value'
+)
 @login_required
 def deposit_parameter_value(trans_id):
     """
@@ -1206,7 +1251,10 @@ def deposit_parameter_value(trans_id):
     return make_json_response(data={'status': status, 'result': result})
 
 
-@blueprint.route('/select_frame/<int:trans_id>/<int:frame_id>', methods=['GET'])
+@blueprint.route(
+    '/select_frame/<int:trans_id>/<int:frame_id>', methods=['GET'],
+    endpoint='select_frame'
+)
 @login_required
 def select_frame(trans_id, frame_id):
     """
@@ -1256,7 +1304,10 @@ def select_frame(trans_id, frame_id):
     return make_json_response(data={'status': status, 'result': result['rows']})
 
 
-@blueprint.route('/get_arguments/<int:sid>/<int:did>/<int:scid>/<int:func_id>', methods=['GET'])
+@blueprint.route(
+    '/get_arguments/<int:sid>/<int:did>/<int:scid>/<int:func_id>',
+    methods=['GET'], endpoint='get_arguments'
+)
 @login_required
 def get_arguments_sqlite(sid, did, scid, func_id):
     """
@@ -1305,7 +1356,10 @@ def get_arguments_sqlite(sid, did, scid, func_id):
         return make_json_response(data={'result': 'result', 'args_count': DbgFuncArgsCount})
 
 
-@blueprint.route('/set_arguments/<int:sid>/<int:did>/<int:scid>/<int:func_id>', methods=['POST'])
+@blueprint.route(
+    '/set_arguments/<int:sid>/<int:did>/<int:scid>/<int:func_id>',
+    methods=['POST'], endpoint='set_arguments'
+)
 @login_required
 def set_arguments_sqlite(sid, did, scid, func_id):
     """
@@ -1382,6 +1436,7 @@ def set_arguments_sqlite(sid, did, scid, func_id):
 
     return make_json_response(data={'status': True, 'result': 'Success'})
 
+
 def convert_data_to_dict(conn, result):
     """
     This function helps us to convert result set into dict
@@ -1422,7 +1477,10 @@ def convert_data_to_dict(conn, result):
     return columns, result
 
 
-@blueprint.route('/poll_end_execution_result/<int:trans_id>/', methods=["GET"])
+@blueprint.route(
+    '/poll_end_execution_result/<int:trans_id>/',
+    methods=["GET"], endpoint='poll_end_execution_result'
+)
 @login_required
 def poll_end_execution_result(trans_id):
     """
@@ -1518,7 +1576,9 @@ def poll_end_execution_result(trans_id):
     return make_json_response(data={'status': status, 'result': result})
 
 
-@blueprint.route('/poll_result/<int:trans_id>/', methods=["GET"])
+@blueprint.route(
+    '/poll_result/<int:trans_id>/', methods=["GET"], endpoint='poll_result'
+)
 @login_required
 def poll_result(trans_id):
     """
diff --git a/web/pgadmin/tools/sqleditor/__init__.py b/web/pgadmin/tools/sqleditor/__init__.py
index d34836c4..a11d22b6 100644
--- a/web/pgadmin/tools/sqleditor/__init__.py
+++ b/web/pgadmin/tools/sqleditor/__init__.py
@@ -25,7 +25,7 @@ from pgadmin.utils.ajax import make_json_response, bad_request, \
 from pgadmin.utils.driver import get_driver
 from pgadmin.utils.sqlautocomplete.autocomplete import SQLAutoComplete
 from pgadmin.misc.file_manager import Filemanager
-
+from pgadmin.utils.menu import MenuItem
 
 from config import PG_DEFAULT_DRIVER, ON_DEMAND_RECORD_COUNT
 
@@ -61,7 +61,14 @@ class SqlEditorModule(PgAdminModule):
     LABEL = gettext("SQL Editor")
 
     def get_own_menuitems(self):
-        return {}
+        return {'tools': [
+            MenuItem(name='mnu_query_tool',
+                     label=gettext('Query tool'),
+                     priority=100,
+                     callback='show_query_tool',
+                     icon='fa fa-question',
+                     url=url_for('help.static', filename='index.html'))
+        ]}
 
     def get_own_javascripts(self):
         return [{
@@ -70,6 +77,7 @@ class SqlEditorModule(PgAdminModule):
             'when': None
         }]
 
+
     def get_panels(self):
         return []
 
diff --git a/web/regression/feature_utils/pgadmin_page.py b/web/regression/feature_utils/pgadmin_page.py
index 89072436..21e45a65 100644
--- a/web/regression/feature_utils/pgadmin_page.py
+++ b/web/regression/feature_utils/pgadmin_page.py
@@ -194,6 +194,7 @@ class PgadminPage:
             except (NoSuchElementException, WebDriverException):
                 return False
 
+        time.sleep(1)
         WebDriverWait(self.driver, timeout=self.timeout, poll_frequency=0.01).\
             until(find_codemirror, "Timed out waiting for codemirror to appear").\
             click()
diff --git a/web/webpack.config.js b/web/webpack.config.js
index 49f0c4e7..44a5d7bd 100644
--- a/web/webpack.config.js
+++ b/web/webpack.config.js
@@ -1,27 +1,109 @@
 /* eslint-env node */
-
+const path = require('path');
+const webpack = require('webpack');
+const webpackShimConfig = require('./webpack.shim');
+const PRODUCTION = process.env.NODE_ENV === 'production';
+const envType = PRODUCTION ? 'prod': 'dev';
+const OptimizeCssAssetsPlugin = require('optimize-css-assets-webpack-plugin');
+const sourceDir = __dirname + '/pgadmin/static';
 const ExtractTextPlugin = require('extract-text-webpack-plugin');
+const extractLib = new ExtractTextPlugin('style.css');
+const extractSass = new ExtractTextPlugin('pgadmin.css');
+const HardSourceWebpackPlugin = require('hard-source-webpack-plugin');
+
+const vendorChunks = new webpack.optimize.CommonsChunkPlugin({
+  name: 'vendor',
+  chunks: ['app.bundle', 'sqleditor', 'codemirror', 'debugger_direct'],
+  filename: 'vendor.js',
+  minChunks: function(module) {
+    return webpackShimConfig.isExternal(module);
+  },
+});
+
+const pgAdminCommonChunks = new webpack.optimize.CommonsChunkPlugin({
+  name: 'pgadmin_commons',
+  chunks: ['app.bundle', 'sqleditor', 'codemirror', 'debugger_direct'],
+  filename: 'pgadmin_commons.js',
+  minChunks: function(module) {
+    return webpackShimConfig.isPgAdminLib(module);
+  },
+});
+
+const providePlugin = new webpack.ProvidePlugin({
+  $: 'jquery',
+  jQuery: 'jquery',
+  'window.jQuery': 'jquery',
+  _: 'underscore',
+  S: 'underscore.string',
+  Backbone: 'backbone',
+  Backgrid: 'backgrid',
+  pgAdmin: 'pgadmin',
+});
+
+const uglifyPlugin = new webpack.optimize.UglifyJsPlugin({
+  output: {comments: false},
+  compress: {
+    warnings: false,
+    unused: true,
+    dead_code: true,
+    drop_console: true,
+  },
+});
 
-const extractSass = new ExtractTextPlugin({
-  filename: '[name].css',
-  disable: process.env.NODE_ENV === 'development',
+const optimizeAssetsPlugin = new OptimizeCssAssetsPlugin({
+  assetNameRegExp: /\.css$/g,
+  cssProcessor: require('cssnano'),
+  cssProcessorOptions: { discardComments: {removeAll: true } },
+  canPrint: true,
+});
+
+const definePlugin = new webpack.DefinePlugin({
+  'process.env': {
+    'NODE_ENV': JSON.stringify('production'),
+  },
+});
+
+const hardSourceWebpackPlugin = new HardSourceWebpackPlugin({
+  cacheDirectory: './.cache/hard-source/' + envType +'/[confighash]',
+  recordsPath: './.cache/hard-source/' + envType +'/[confighash]/records.json',
+  configHash: require('node-object-hash')({sort: false}).hash,
+  environmentHash: {
+    root: process.cwd(),
+    directories: ['node_modules'],
+    files: ['package.json'],
+  },
 });
 
 module.exports = {
-  context: __dirname + '/pgadmin/static',
+  stats: { children: false },
+  context: __dirname,
   entry: {
-    reactComponents: './bundle/components.js',
-    history: './js/history/index.js',
-    slickgrid: './bundle/slickgrid.js',
-    pgadmincss: './scss/pgadmin.scss',
+    'app.bundle': sourceDir + '/bundle/app.js',
+    //reactComponents: sourceDir + '/bundle/reactJS.js',
+    codemirror: sourceDir + '/bundle/codemirror.js',
+    sqleditor: './pgadmin/tools/sqleditor/templates/sqleditor/js/sqleditor.js',
+    debugger_direct: './pgadmin/tools/debugger/templates/debugger/js/direct.js',
+    file_utils: './pgadmin/misc/file_manager/templates/file_manager/js/utility.js',
+    pgadmin_css: './pgadmin/static/scss/pgadmin.scss',
+    lib_css: './pgadmin/static/css/lib.css',
   },
   output: {
     libraryTarget: 'amd',
     path: __dirname + '/pgadmin/static/js/generated',
     filename: '[name].js',
+    libraryExport: 'default',
+  },
+  /*Templates files to be loaded dynamically*/
+  externals: {
+    'pgadmin.browser.messages': 'pgadmin.browser.messages',
+    'pgadmin.browser.utils': 'pgadmin.browser.utils',
+    'pgadmin.browser.endpoints': 'pgadmin.browser.endpoints',
+    'pgadmin.server.supported_servers': 'pgadmin.server.supported_servers',
+    'pgadmin.user_management.current_user': 'pgadmin.user_management.current_user',
+    'pgadmin.node.unique_key': 'pgadmin.node.unique_key',
+    'translations': 'translations',
   },
 
-  plugins: [extractSass],
   module: {
     rules: [{
       test: /\.jsx?$/,
@@ -33,8 +115,120 @@ module.exports = {
         },
       },
     }, {
-      test: /\.css$/,
-      use: ['style-loader', 'raw-loader'],
+      test: /\.js/,
+      loader: 'shim-loader',
+      query: webpackShimConfig,
+      include: path.join(__dirname, '/pgadmin/browser'),
+    }, {
+      test: require.resolve('./pgadmin/tools/datagrid/templates/datagrid/js/datagrid'),
+      use: {
+        loader: 'imports-loader?' +
+        'pgadmin.dashboard' +
+        ',pgadmin.tools.user_management' +
+        ',misc.statistics' +
+        ',misc.depends' +
+        ',misc.sql' +
+        ',misc.bgprocess' +
+        ',pgadmin.node.server_group' +
+        ',pgadmin.node.server' +
+        ',pgadmin.node.database' +
+        ',pgadmin.node.role' +
+        ',pgadmin.node.cast' +
+        ',pgadmin.node.tablespace' +
+        ',pgadmin.node.resource_group' +
+        ',pgadmin.node.event_trigger' +
+        ',pgadmin.node.extension' +
+        ',pgadmin.node.language' +
+        ',pgadmin.node.foreign_data_wrapper' +
+        ',pgadmin.node.schema' +
+        ',pgadmin.node.catalog' +
+        ',pgadmin.node.catalog_object' +
+        ',pgadmin.node.collation' +
+        ',pgadmin.node.domain' +
+        ',pgadmin.node.domain_constraints' +
+        ',pgadmin.node.foreign_table' +
+        ',pgadmin.node.fts_configuration' +
+        ',pgadmin.node.fts_dictionary' +
+        ',pgadmin.node.fts_parser' +
+        ',pgadmin.node.fts_template' +
+        ',pgadmin.node.function' +
+        ',pgadmin.node.procedure' +
+        ',pgadmin.node.edbfunc' +
+        ',pgadmin.node.edbproc' +
+        ',pgadmin.node.edbvar' +
+        ',pgadmin.node.edbvar' +
+        ',pgadmin.node.trigger_function' +
+        ',pgadmin.node.package' +
+        ',pgadmin.node.sequence' +
+        ',pgadmin.node.synonym' +
+        ',pgadmin.node.type' +
+        ',pgadmin.node.rule' +
+        ',pgadmin.node.index' +
+        ',pgadmin.node.trigger' +
+        ',pgadmin.node.catalog_object_column' +
+        ',pgadmin.node.view' +
+        ',pgadmin.node.mview' +
+        ',pgadmin.node.table',
+      },
+    }, {
+      test: require.resolve('./node_modules/acitree/js/jquery.aciTree.min'),
+      use: {
+        loader: 'imports-loader?this=>window',
+      },
+    }, {
+      test: require.resolve('./node_modules/acitree/js/jquery.aciPlugin.min'),
+      use: {
+        loader: 'imports-loader?this=>window',
+      },
+    }, {
+      test: require.resolve('./pgadmin/static/bundle/browser'),
+      use: {
+        loader: 'imports-loader?' +
+        'pgadmin.about' +
+        ',pgadmin.preferences' +
+        ',misc.file_manager' +
+        ',pgadmin.settings' +
+        ',tools.backup' +
+        ',tools.restore' +
+        ',tools.grant_wizard' +
+        ',tools.maintenance' +
+        ',tools.import_export' +
+        ',tools.debugger' +
+        ',tools.direct',
+      },
+    }, {
+      test: require.resolve('snapsvg'),
+      use: {
+        loader: 'imports-loader?this=>window,fix=>module.exports=0',
+      },
+    }, {
+      test: /\.(jpe?g|png|gif|svg)$/i,
+      loaders: [
+        'file-loader?hash=sha512&digest=hex&name=img/[name].[ext]', {
+          loader: 'image-webpack-loader',
+          query: {
+            bypassOnDebug: true,
+            mozjpeg: {
+              progressive: true,
+            },
+            gifsicle: {
+              interlaced: false,
+            },
+            optipng: {
+              optimizationLevel: 7,
+            },
+            pngquant: {
+              quality: '75-90',
+              speed: 3,
+            },
+          },
+        },
+      ],
+      exclude: /vendor/,
+    }, {
+      test: /\.(eot|svg|ttf|woff|woff2)$/,
+      loader: 'file-loader?name=fonts/[name].[ext]',
+      exclude: /vendor/,
     }, {
       test: /\.scss$/,
       use: extractSass.extract({
@@ -42,12 +236,43 @@ module.exports = {
           loader: 'css-loader',
         }, {
           loader: 'sass-loader', // compiles Sass to CSS
+          options: {
+            includePaths: ['./pgadmin/static/scss/'],
+          },
+        }],
+      }),
+    }, {
+      test: /\.css$/,
+      use: extractLib.extract({
+        use: [{
+          loader: 'css-loader',
         }],
       }),
     }],
+    noParse: [/moment.js/],
   },
-
   resolve: {
+    alias: webpackShimConfig.resolveAlias,
+    modules: ['node_modules', '.'],
     extensions: ['.js', '.jsx'],
+    unsafeCache: true,
   },
-};
\ No newline at end of file
+  plugins: PRODUCTION ? [
+    extractSass,
+    extractLib,
+    vendorChunks,
+    pgAdminCommonChunks,
+    providePlugin,
+    uglifyPlugin,
+    optimizeAssetsPlugin,
+    definePlugin,
+    hardSourceWebpackPlugin,
+  ]: [
+    extractSass,
+    extractLib,
+    vendorChunks,
+    pgAdminCommonChunks,
+    providePlugin,
+    hardSourceWebpackPlugin,
+  ],
+};
diff --git a/web/webpack.debug.config.js b/web/webpack.debug.config.js
new file mode 100644
index 00000000..96f4e730
--- /dev/null
+++ b/web/webpack.debug.config.js
@@ -0,0 +1,17 @@
+const baseConfig = require('./webpack.config.js');
+const RawSource = require('webpack-sources').RawSource;
+
+baseConfig.plugins.push(function() {
+  this.plugin('emit', (compilation, callback) => {
+    compilation.chunks.forEach((chunk) => {
+      chunk.files.filter((filename) => /\.js$/.test(filename)).forEach((filename) => {
+        var source = compilation.assets[filename].source();
+
+        compilation.assets[filename] = new RawSource(source.replace(/__WEBPACK_IMPORTED_MODULE_/g, '__'));
+      });
+    });
+    callback();
+  });
+});
+
+module.exports = baseConfig;
